//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrBlue
#property indicator_color2  clrRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1


//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

//
//
//
//
//

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame               = PERIOD_CURRENT;
extern enPrices        SSAPrice                = pr_close; // Price to use 
extern int             SSALag                  = 25;
extern int             SSANumberOfComputations = 2;
extern int             SSANumberOfBars         = 300;
extern int             FirstBar                = 300; 
extern bool            alertsOn                = false;
extern bool            alertsOnCurrent         = true;
extern bool            alertsMessage           = true;
extern bool            alertsSound             = false;
extern bool            alertsEmail             = false;
extern bool            alertsNotify            = false;
extern string          soundFile               = "alert2.wav";
extern bool            arrowsVisible           = false;            // Arrows visible?
extern bool            arrowsOnNewest          = false;            // Arrows drawn on newst bar of higher time frame bar?
extern string          arrowsIdentifier        = "ssa Arrows1";    // Unique ID for arrows
extern double          arrowsUpperGap          = 1.0;              // Upper arrow gap
extern double          arrowsLowerGap          = 1.0;              // Lower arrow gap
extern color           arrowsUpColor           = clrLimeGreen;     // Up arrow color
extern color           arrowsDnColor           = clrOrange;        // Down arrow color
extern int             arrowsUpCode            = 241;              // Up arrow code
extern int             arrowsDnCode            = 242;              // Down arrow code


//
//
//
//
//

double in[];
double ssaDa[];
double ssaDb[];
double pr[];
double slope[];
double ssaIn[];
double ssaOut[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,ssaDa); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,ssaDb); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,in);
      SetIndexBuffer(3,pr);
      SetIndexBuffer(4,slope);
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
         
   IndicatorShortName(timeFrameToString(TimeFrame)+" SSA normalized end-pointed");
return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
return(0);
}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);
      if (returnBars) { ssaDa[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (TimeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        pr[i] = getPrice(SSAPrice,Open,Close,High,Low,i);

        //
        //
        //
        //
        //
      
        if (i<=FirstBar)
        {
           int ssaBars = MathMin(Bars-i,SSANumberOfBars);
           if (ssaBars<SSALag) continue;
              if (ArraySize(ssaIn) != ssaBars)
              {
                 ArrayResize(ssaIn ,ssaBars);
                 ArrayResize(ssaOut,ssaBars);
              }
              ArrayCopy(ssaIn,pr,0,i,ssaBars);
      
          fastSingular(ssaIn,ssaBars,SSALag,SSANumberOfComputations,ssaOut);
          in[i]=ssaOut[0];
          
          ssaDa[i] = EMPTY_VALUE;
          ssaDb[i] = EMPTY_VALUE;
          slope[i] = slope[i+1];
          if (in[i]<in[i+1]) slope[i] =-1;
          if (in[i]>in[i+1]) slope[i] = 1;
          if (slope[i] == 1) ssaDa[i] = 1;
          if (slope[i] ==-1) ssaDb[i] = 1;
          
          //
          //
          //
          //
          //
      
          if (arrowsVisible)
          {
             string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
                 if (slope[i] != slope[i+1])
                 {
                    if (slope[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                    if (slope[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                 }
          }
       }                   
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (slope[whichBar] != slope[whichBar+1])
     if (slope[whichBar] == 1)
           doAlert("sloping up");
     else  doAlert("sloping down");       
   }        
   SetIndexDrawBegin(0,Bars-FirstBar);  
   SetIndexDrawBegin(1,Bars-FirstBar);
   SetIndexDrawBegin(2,Bars-FirstBar);                  
   return(0); 
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ssaDa[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundFile,arrowsVisible,arrowsOnNewest,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,0,y);
         ssaDb[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSAPrice,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundFile,arrowsVisible,arrowsOnNewest,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,1,y);         
   }
   SetIndexDrawBegin(0,Bars-FirstBar*TimeFrame/Period());
   SetIndexDrawBegin(1,Bars-FirstBar*TimeFrame/Period());
   SetIndexDrawBegin(2,Bars-FirstBar*TimeFrame/Period());
return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //

      datetime time = Time[i]; if (arrowsOnNewest) time += _Period*60-1;      
      ObjectCreate(name,OBJ_ARROW,0,time,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SSA end-pointed ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SSA end-pointed "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

